EaBIM

标题: 找到墙的正面 [打印本页]

作者: 萧闫子    时间: 2014-1-9 13:06
标题: 找到墙的正面
Wall.Orientation指示墙的正方向,判断Face与这个正方向的夹角一致,即为墙的正面。

//找到墙的正面

  1. public static Face FindWallFace(Wall wall)
  2. {
  3.     Face normalFace = null;
  4.     //
  5.     Options opt = new Options();
  6.     opt.ComputeReferences = true;
  7.     opt.DetailLevel = Autodesk.Revit.DB.DetailLevels.Medium;
  8.     //
  9.     GeometryElement e = wall.get_Geometry(opt);
  10.     foreach (GeometryObject obj in e.Objects)
  11.     {
  12.         Solid solid = obj as Solid;
  13.         if (solid != null && solid.Faces.Size > 0)
  14.         {
  15.             foreach (Face face in solid.Faces)
  16.             {
  17.                 PlanarFace pf = face as PlanarFace;
  18.                 if (pf != null)
  19.                 {
  20.                     if (pf.Normal.AngleTo(wall.Orientation) < 0.01)//数值在0到PI之间
  21.                     {
  22.                         normalFace = face;
  23.                     }
  24.                 }
  25.             }
  26.         }
  27.     }
  28.     return normalFace;
  29. }
复制代码

作者: We晕晕    时间: 2014-2-20 14:34
顶!!!!!!!!!!




欢迎光临 EaBIM (https://eabim.net/) Powered by Discuz! X3.2